#include <SSD1306.h>
#include <OLEDDisplay.h>
#include <Wire.h>
#include <WiFi.h>                    
#define SSID "**********"          // 無線LANアクセスポイントのSSID
#define PASS "**********"              // パスワード
SSD1306 display(0x3c, 5, 4); // /SSD1306インスタンスの作成（I2Cアドレス,SDA,SCL）
int AIN1=13;
int AIN2=12;
String lip;
WiFiServer server(80);
void setup() {
  WiFi.mode(WIFI_STA);                    // 無線LANをSTAモードに設定
  WiFi.begin(SSID,PASS);                  // 無線LANアクセスポイントへ接続
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    delay(500);                           // 待ち時間処理
  }
  lip=WiFi.localIP().toString();   // IPアドレスを取得
  display.init();

  display.setColor(WHITE);
  display.setFont(ArialMT_Plain_10);    //フォントを設定
  disp_oled("STOP");
  pinMode (AIN1, OUTPUT);
  pinMode (AIN2, OUTPUT);
  digitalWrite(AIN1,LOW);
  digitalWrite(AIN2,LOW);
  server.begin();
}
void loop() { 
  WiFiClient client = server.available();
 
  if (client) {
    Serial.println("new client");
    String currentLine = "";
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);
        if (c == '\n') {
          if (currentLine.length() == 0) {
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println();
 
            client.println("<!DOCTYPE html>");
            client.println("<html>");
            client.println("<head>");
            client.println("<meta name='viewport' content='initial-scale=1.5'>");
            client.println("</head>");
            client.println("<body>");
            client.println("<form method='get'>");
            client.println("<font size='4'>Mechanical Turtle<br>");
            client.println("<font size='4'>DC Motor Control<br>");
            client.println("</font><br>");
            client.println("<br>");
            client.println("<input type='submit' name=0 value='GO' style='background-color:#88ff88; color:blue;'>");
            client.println("<input type='submit' name=2 value='STOP' style='background-color:#88ff88; color:red;'>");
            client.println("<input type='submit' name=1 value='BACK' style='background-color:#88ff88; color:black;'>");
            client.println("</form>");
            client.println("</body>");
            client.println("</html>");
 
            client.println();
            break;
          } else {
            currentLine = "";
          }
        } else if (c != '\r') {
          currentLine += c;
        }
 
        if (currentLine.endsWith("GET /?0=GO")) {
          digitalWrite(AIN1, LOW);
          digitalWrite(AIN2, HIGH);
          disp_oled("GO");
        }
        if (currentLine.endsWith("GET /?1=BACK")) {
          digitalWrite(AIN1, HIGH);
          digitalWrite(AIN2, LOW);
          disp_oled("BACK");
        }
        if (currentLine.endsWith("GET /?2=STOP")) {
          digitalWrite(AIN1, LOW);
          digitalWrite(AIN2, LOW);
          disp_oled("STOP");
        }
      }
    }
     
    client.stop();
    Serial.println("client disonnected");
  }
}
void disp_oled(String str){
  display.clear();
  display.drawRect(5, 5, 117, 53); //長方形の描画
  display.drawString(10, 7, "Mechanical Turtle"); //以下文字列の表示
  display.drawString(10, 19, "DC Motor Control");
  display.drawString(10, 31, "IP ADR:"+lip);
  display.drawString(10, 43, str);
  display.display();
}
